Apache Flink® Downloads #

Apache Flink® 1.18.0 is the latest stable release.

Apache Flink 1.18.1 (asc, sha512)

Apache Flink 1.18.1 Source Release (asc, sha512)

Release Notes #

Please have a look at the Release Notes for Apache Flink 1.18.1 if you plan to upgrade your Flink setup from a previous version.

Apache Flink 1.17.2 (asc, sha512)

Apache Flink 1.17.2 Source Release (asc, sha512)

Release Notes #

Please have a look at the Release Notes for Apache Flink 1.17.2 if you plan to upgrade your Flink setup from a previous version.

Apache Flink 1.16.3 (asc, sha512)

Apache Flink 1.16.3 Source Release (asc, sha512)

Release Notes #

Please have a look at the Release Notes for Apache Flink 1.16.3 if you plan to upgrade your Flink setup from a previous version.

These are connectors that are released separately from the main Flink releases.

Apache Flink AWS Connectors 4.2.0 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.17.x

  • 1.18.x

Apache Flink Cassandra Connector 3.1.0 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.16.x

  • 1.17.x

Apache Flink Elasticsearch Connector 3.0.1 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.16.x

  • 1.17.x

Apache Flink Google Cloud PubSub Connector 3.0.2 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.17.x

  • 1.18.x

Apache Flink HBase Connector 3.0.0 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.16.x

  • 1.17.x

Apache Flink JDBC Connector 3.1.2 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.16.x

  • 1.17.x

  • 1.18.x

Apache Flink Kafka Connector 3.1.0 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.17.x

  • 1.18.x

Apache Flink MongoDB Connector 1.1.0 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.17.x

  • 1.18.x

Apache Flink Opensearch Connector 1.1.0 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.17.x

  • 1.18.x

Apache Flink Pulsar Connector 3.0.1 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.16.x

Apache Flink Pulsar Connector 4.1.0 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.17.x

  • 1.18.x

Apache Flink RabbitMQ Connector 3.0.1 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.16.x

  • 1.17.x

Apache Flink® Stateful Functions 3.3 is the latest stable release.

Apache Flink Stateful Functions 3.3.0 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.16.2

Apache Flink® ML 2.3 is the latest stable release.

Apache Flink ML 2.3.0 Source Release (asc, sha512)

Apache Flink ML 2.3.0 Python Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.17.*

Apache Flink ML 2.2.0 Source Release (asc, sha512)

Apache Flink ML 2.2.0 Python Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.15.*

Apache Flink® Kubernetes Operator 1.7 is the latest stable release.

Apache Flink Kubernetes Operator 1.7.0 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.18.x

  • 1.17.x

  • 1.16.x

  • 1.15.x

Apache Flink Kubernetes Operator 1.6.1 Source Release (asc, sha512)

This component is compatible with Apache Flink version(s):

  • 1.18.x

  • 1.17.x

  • 1.16.x

  • 1.15.x

  • 1.14.x

  • 1.13.x

Apache Flink® Table Store 0.3 is the last release when it’s still a sub-project of Flink, it has joined as Apache Paimon(incubating) currently.

Please refer to Paimon-downloads to get the latest jars.

Additional Components #

These are components that the Flink project develops which are not part of the main Flink release:

Pre-bundled Hadoop 2.8.3 #

Pre-bundled Hadoop 2.8.3 Source Release (asc, sha512)

Pre-bundled Hadoop 2.7.5 #

Pre-bundled Hadoop 2.7.5 Source Release (asc, sha512)

Pre-bundled Hadoop 2.6.5 #

Pre-bundled Hadoop 2.6.5 Source Release (asc, sha512)

Pre-bundled Hadoop 2.4.1 #

Pre-bundled Hadoop 2.4.1 Source Release (asc, sha512)

Apache Flink-shaded 18.0 Source Release Source Release (asc, sha512)

Apache Flink-shaded 17.0 Source Release Source Release (asc, sha512)

Apache Flink-shaded 16.2 Source Release Source Release (asc, sha512)

Apache Flink-connector-parent 1.0.0 Source release Source Release (asc, sha512)

Verifying Hashes and Signatures #

Along with our releases, we also provide sha512 hashes in *.sha512 files and cryptographic signatures in *.asc files. The Apache Software Foundation has an extensive tutorial to verify hashes and signatures which you can follow by using any of these release-signing KEYS.

Maven Dependencies #

You can add the following dependencies to your pom.xml to include Apache Flink in your project. These dependencies include a local execution environment and thus support local testing.

  • Scala API: To use the Scala API, replace the flink-java artifact id with flink-scala_2.12 and flink-streaming-java with flink-streaming-scala_2.12.
<dependency>
  <groupId>org.apache.flink</groupId>
  <artifactId>flink-java</artifactId>
  <version>1.18.0</version>
</dependency>
<dependency>
  <groupId>org.apache.flink</groupId>
  <artifactId>flink-streaming-java</artifactId>
  <version>1.18.0</version>
</dependency>
<dependency>
  <groupId>org.apache.flink</groupId>
  <artifactId>flink-clients</artifactId>
  <version>1.18.0</version>
</dependency>

You can add the following dependencies to your pom.xml to include Apache Flink Stateful Functions in your project.

<dependency>
  <groupId>org.apache.flink</groupId>
  <artifactId>statefun-sdk</artifactId>
  <version>3.3.0</version>
</dependency>
<dependency>
  <groupId>org.apache.flink</groupId>
  <artifactId>statefun-flink-harness</artifactId>
  <version>3.3.0</version>
</dependency>

The statefun-sdk dependency is the only one you will need to start developing applications. The statefun-flink-harness dependency includes a local execution environment that allows you to locally test your application in an IDE.

You can add the following dependencies to your pom.xml to include Apache Flink ML in your project.

<dependency>
  <groupId>org.apache.flink</groupId>
  <artifactId>flink-ml-core</artifactId>
  <version>2.3.0</version>
</dependency>
<dependency>
  <groupId>org.apache.flink</groupId>
  <artifactId>flink-ml-iteration</artifactId>
  <version>2.3.0</version>
</dependency>
<dependency>
  <groupId>org.apache.flink</groupId>
  <artifactId>flink-ml-lib</artifactId>
  <version>2.3.0</version>
</dependency>

Advanced users could only import a minimal set of Flink ML dependencies for their target use-cases:

  • Use artifact flink-ml-core in order to develop custom ML algorithms.
  • Use artifacts flink-ml-core and flink-ml-iteration in order to develop custom ML algorithms which require iteration.
  • Use artifact flink-ml-lib in order to use the off-the-shelf ML algorithms from Flink ML.

You can add the following dependencies to your pom.xml to include Apache Flink Kubernetes Operator in your project.

<dependency>
  <groupId>org.apache.flink</groupId>
  <artifactId>flink-kubernetes-operator</artifactId>
  <version>1.7.0</version>
</dependency>

Update Policy for old releases #

As of March 2017, the Flink community decided to support the current and previous minor release with bugfixes. If 1.2.x is the current release, 1.1.y is the previous minor supported release. Both versions will receive bugfixes for critical issues.

As of March 2023, the Flink community decided that upon release of a new Flink minor version, the community will perform one final bugfix release for resolved critical/blocker issues in the Flink minor version losing support. If 1.16.1 is the current release and 1.15.4 is the latest previous patch version, once 1.17.0 is released we will create a 1.15.5 to flush out any resolved critical/blocker issues.

Note that the community is always open to discussing bugfix releases for even older versions. Please get in touch with the developers for that on the dev@flink.apache.org mailing list.

All stable releases #

All Flink releases are available via https://archive.apache.org/dist/flink/ including checksums and cryptographic signatures. At the time of writing, this includes the following versions:

  • Flink Elasticsearch Connector 3.0.0 - 2022-11-09 (Source)
  • Flink AWS Connectors 3.0.0 - 2022-11-28 (Source)
  • Flink Cassandra Connector 3.0.0 - 2022-11-30 (Source)
  • Flink AWS Connectors 4.0.0 - 2022-12-09 (Source)
  • Flink Pulsar Connector 3.0.0 - 2022-12-20 (Source)
  • Flink JDBC Connector 3.0.0 - 2022-11-30 (Source)
  • Flink RabbitMQ Connectors 3.0.0 - 2022-12-13 (Source)
  • Flink Opensearch Connector 1.0.0 - 2022-12-21 (Source)
  • Flink Google Cloud PubSub Connector 3.0.0 - 2023-01-31 (Source)
  • Flink MongoDB Connector 1.0.0 - 2023-04-03 (Source)
  • Flink AWS Connectors 4.1.0 - 2023-04-03 (Source)
  • Flink Kafka Connector 3.0.0 - 2023-04-21 (Source)
  • Flink MongoDB Connector 1.0.1 - 2023-04-24 (Source)
  • Flink JDBC Connector 3.1.0 - 2023-05-05 (Source)
  • Flink RabbitMQ Connectors 3.0.1 - 2023-05-08 (Source)
  • Flink Elasticsearch Connector 3.0.1 - 2023-05-08 (Source)
  • Flink Opensearch Connector 1.0.1 - 2023-05-08 (Source)
  • Flink Pulsar Connector 4.0.0 - 2023-05-08 (Source)
  • Flink Google Cloud PubSub Connector 3.0.1 - 2023-05-09 (Source)
  • Flink Cassandra Connector 3.1.0 - 2023-05-25 (Source)
  • Flink Pulsar Connector 3.0.1 - 2023-06-07 (Source)
  • Flink JDBC Connector 3.1.1 - 2023-06-28 (Source)
  • Flink MongoDB Connector 1.0.2 - 2023-08-15 (Source)
  • Flink HBase Connector 3.0.0 - 2023-09-1 (Source)
  • Flink Kafka Connector 3.0.1 - 2023-10-30 (Source)
  • Flink AWS Connectors 4.2.0 - 2023-11-30 (Source)
  • Flink Kafka Connector 3.0.2 - 2023-12-01 (Source)
  • Flink Pulsar Connector 4.1.0 - 2023-12-28 (Source)
  • Flink Google Cloud PubSub Connector 3.0.2 - 2024-01-12 (Source)
  • Flink Opensearch Connector 1.1.0 - 2024-02-01 (Source)
  • Flink Kafka Connector 3.1.0 - 2024-02-07 (Source)
  • Flink MongoDB Connector 1.1.0 - 2024-02-19 (Source)
  • Flink JDBC Connector 3.1.2 - 2024-02-21 (Source)
  • Apache Flink Shaded 18.0 - 2024-01-11 (Source)
  • Apache Flink Shaded 17.0 - 2023-05-08 (Source)
  • Apache Flink Shaded 16.2 - 2023-11-17 (Source)
  • Apache Flink Shaded 16.1 - 2022-11-24 (Source)
  • Apache Flink Shaded 16.0 - 2022-10-07 (Source)
  • Apache Flink Shaded 15.0 - 2022-01-21 (Source)
  • Apache Flink Shaded 14.0 - 2021-07-21 (Source)
  • Apache Flink Shaded 13.0 - 2021-04-06 (Source)
  • Apache Flink Shaded 12.0 - 2020-10-09 (Source)
  • Apache Flink Shaded 11.0 - 2020-05-29 (Source)
  • Apache Flink Shaded 10.0 - 2020-02-17 (Source)
  • Apache Flink Shaded 9.0 - 2019-11-23 (Source)
  • Apache Flink Shaded 8.0 - 2019-08-28 (Source)
  • Apache Flink Shaded 7.0 - 2019-05-30 (Source)
  • Apache Flink Shaded 6.0 - 2019-02-12 (Source)
  • Apache Flink Shaded 5.0 - 2018-10-15 (Source)
  • Apache Flink Shaded 4.0 - 2018-06-06 (Source)
  • Apache Flink Shaded 3.0 - 2018-02-28 (Source)
  • Apache Flink Shaded 2.0 - 2017-10-30 (Source)
  • Apache Flink Shaded 1.0 - 2017-07-27 (Source)
  • Apache Flink ML 2.3.0 - 2023-07-01 (Source)
  • Apache Flink ML 2.2.0 - 2023-04-19 (Source)
  • Apache Flink ML 2.1.0 - 2022-07-12 (Source)
  • Apache Flink ML 2.0.0 - 2021-01-07 (Source)